--- a/Zend/zend_vm_def.h	2025-10-21 19:23:55.000000000 +0000
+++ b/Zend/zend_vm_def.h	2025-11-18 21:43:27.133565478 +0000
@@ -7275,7 +7275,7 @@
 			while (1) {
 				if (UNEXPECTED(pos >= fe_ht->nNumUsed)) {
 					/* reached end of iteration */
-					ZEND_VM_C_GOTO(fe_fetch_w_exit);
+					ZEND_VM_C_GOTO(fe_fetch_w_exit_exc);
 				}
 				pos++;
 				value = &p->val;
@@ -7371,6 +7371,7 @@
 		}
 	} else {
 		zend_error(E_WARNING, "foreach() argument must be of type array|object, %s given", zend_zval_value_name(array));
+ZEND_VM_C_LABEL(fe_fetch_w_exit_exc):
 		if (UNEXPECTED(EG(exception))) {
 			UNDEF_RESULT();
 			HANDLE_EXCEPTION();
diff '--color=auto' -Naur a/Zend/zend_vm_execute.h b/Zend/zend_vm_execute.h
--- a/Zend/zend_vm_execute.h	2025-10-21 19:23:55.000000000 +0000
+++ b/Zend/zend_vm_execute.h	2025-11-18 21:43:27.149565685 +0000
@@ -23173,7 +23173,7 @@
 			while (1) {
 				if (UNEXPECTED(pos >= fe_ht->nNumUsed)) {
 					/* reached end of iteration */
-					goto fe_fetch_w_exit;
+					goto fe_fetch_w_exit_exc;
 				}
 				pos++;
 				value = &p->val;
@@ -23269,6 +23269,7 @@
 		}
 	} else {
 		zend_error(E_WARNING, "foreach() argument must be of type array|object, %s given", zend_zval_value_name(array));
+fe_fetch_w_exit_exc:
 		if (UNEXPECTED(EG(exception))) {
 			UNDEF_RESULT();
 			HANDLE_EXCEPTION();
diff '--color=auto' -Naur a/Zend/zend_weakrefs.c b/Zend/zend_weakrefs.c
--- a/Zend/zend_weakrefs.c	2025-10-21 19:23:55.000000000 +0000
+++ b/Zend/zend_weakrefs.c	2025-11-18 21:43:27.150565698 +0000
@@ -722,7 +722,7 @@
 		RETURN_THROWS();
 	}
 
-	ZVAL_COPY(return_value, zv);
+	RETURN_COPY_DEREF(zv);
 }
 
 ZEND_METHOD(WeakMap, offsetSet)
diff '--color=auto' -Naur a/configure.ac b/configure.ac
--- a/configure.ac	2025-10-21 19:23:55.000000000 +0000
+++ b/configure.ac	2025-11-18 21:48:08.951188482 +0000
@@ -17,7 +17,7 @@
 dnl ----------------------------------------------------------------------------
 
 AC_PREREQ([2.68])
-AC_INIT([PHP],[8.4.14],[https://github.com/php/php-src/issues],[php],[https://www.php.net])
+AC_INIT([PHP],[8.4.15],[https://github.com/php/php-src/issues],[php],[https://www.php.net])
 AC_CONFIG_SRCDIR([main/php_version.h])
 AC_CONFIG_AUX_DIR([build])
 AC_PRESERVE_HELP_ORDER
diff '--color=auto' -Naur a/configure.ac.orig b/configure.ac.orig
